/****************************************************************************/
/*																			*/
/*		STK-7125 TvvO											*/
/*			u[g														*/
/*																			*/
/*			Copyright   :: At@vWFNg							*/
/*			Cpu         :: SH7125											*/
/*			Language    :: SH-C												*/
/*			File Name   :: boot.c											*/
/*																			*/
/****************************************************************************/
#include <machine.h>
#include "7125s.h"
#include "common.h"
#include "timer.h"
#include "sci.h"

/* OQ */
extern void	set_imask(int);
extern int	main(void);

/************************************/
/*	ZNV				*/
/************************************/
void sectionInit(void)
{
	extern int	*_D_ROM, *_B_BGN, *_B_END, *_D_BGN, *_D_END;
	register int	*p, *q;

	/* f[^̈[ŏ */
	for ( p = _B_BGN; p < _B_END; p++ ) {
		*p = 0;
	}
	/* f[^ROMォRAMփRs[ */
	for ( p = _D_BGN, q = _D_ROM; p < _D_END; p++, q++ ) {
		*p = *q;
	}
}

/************************************/
/*	CPU						*/
/************************************/
#pragma	section BOOT
void boot(void)
{
	/* NbNU(CPG) : PLL=96MHz */
	CPG.FRQCR.WORD = 0x16db;		// I=PLL/2,B=PLL/4,P=PLL/4,MP=PLL/4
									// I=48MHz,B=24MHz,P=24MHz,MP=24MHz
	/* st@NV(PFC) */
	PFC.PACRL1.WORD |= 0x0011;		// PA1 :TXD0,PA0 :RXD0
	PFC.PACRL4.WORD |= 0x6600;		// PA15:TXD1,PA14:RXD1
	PFC.PEIORL.WORD |= 0x0001;		// PE0 :OUT(EVB board LD1)
	PFC.PECRL1.WORD |= 0x0001;		// PE0 :TIOC0A

	/* X^oC(STB) */
	STB.CR3.BYTE &= ~0x18;			// SCI0,SCI1X^oC
	STB.CR4.BYTE &= ~0x20;			// CMTX^oC
	STB.CR4.BYTE &= ~0x40;			// MTU2̃X^oC[h

	/*  */
	sectionInit();

	/* foCX */
	timer_init(0);					// CMT0 : 1mS interval,callback,MTU20 : PWM [h1
	sci_init();						// SCI1 : 38400,8,1,N

	/* ݉ */
	set_imask(0);

	/* C֐ďo */
	main();
}
#pragma	section
