/****************************************************************************/
/*																			*/
/*		STK-7125 TvvO											*/
/*			^C}														*/
/*																			*/
/*			Copyright   :: At@vWFNg							*/
/*			Cpu         :: SH7125											*/
/*			Language    :: SH-C												*/
/*			File Name   :: timer.c											*/
/*																			*/
/****************************************************************************/
#include "common.h"
#include "7125s.h"
#include "timer.h"

/* 1ms_E^C} */
unsigned long TMR1m[TMR_NUM];

/* R[obN֐` */
static TIMER_CALLBACK fnc = 0;

/************************************/
/*	CMT0R[obN֐ݒ		*/
/************************************/
void timer_callback(TIMER_CALLBACK cback)
{
	fnc = cback;
}

/************************************/
/*	CMT0,MTU20				*/
/************************************/
void timer_init(TIMER_CALLBACK cback)
{
	/* CMT0̐ݒ */
	timer_callback(cback);			// R[obN֐ݒ

	CMT.CMSTR.WORD &= ~0x0001;		// ^C}~

	INTC.IPRJ.WORD = (INTC.IPRJ.WORD & ~0xf000) | 0x7000;
									// ݃x̐ݒ : Lv7

	CMT0.CMCNT = 0;					// JE^lݒ
	CMT0.CMCOR = (PCLK/8/1000)-1;	// 1msecC^[o
	CMT0.CMCSR.WORD = 0x0040;

	CMT.CMSTR.WORD |= 0x0001;		// ^C}X^[g


	/* MTU20̐ݒ */
	MTU2.TSTR.BYTE &= ~0x01;		// JEg~
	MTU20.TCR.BYTE = 0x4A;			// TGRB̃RyA}b`ŃJE^NA
									// オGbWŃJEg,MP/4ŃJEg
									// TCNT̃JEgAbvɂ鎞 TCNT(s) = 1/iMP/16j
									// TCNT(S)͖0.67ns

	MTU20.TIOR.BYTE.H = 0x12;		// TGR0B,TGR0A̐ݒ TGRARyA}b`
	
	MTU20.TGRA = PERIOD;			// lf[eB 0ɐݒ
	MTU20.TGRB = PERIOD;			//  P(s)= TGRB̒l * TCNT(s) 670ns
	MTU20.TCNT = 0x0000;			// JE^NA
	MTU20.TSR.BYTE = 0xC0;			// AbvJEg

	MTU20.TMDR.BYTE = 0x02;			// PWM[h1
	MTU2.TSTR.BYTE |= 0x01;			// JEgn
}

/************************************/
/*	CMT0(1ms)				*/
/************************************/
#pragma interrupt (timer_int)
void timer_int(void)
{
	int	i;

	CMT0.CMCSR.WORD &= ~0x0080;

	for(i=0;i<TMR_NUM;i++) {
		if(TMR1m[i]) --TMR1m[i];
	}

	if(fnc)
		fnc();	// R[obN֐ďo
}

